clc
clear 
close all

figure
I = imread('try.bmp');
imshow(I,[]);
title('Orignal image');

RGB = mat2gray(I);
R_show = RGB(:,:,1);
G_show = RGB(:,:,2);
B_show = RGB(:,:,3);

figure
% RGB2YUV
Y = 0.299*R_show + 0.587*G_show + 0.114*B_show;
U = -0.147*R_show- 0.289*G_show + 0.437*B_show;
V = 0.615*R_show - 0.515*G_show - 0.100*B_show;
YUV = cat(3, Y, U, V);

U_show = RGB;
U_show(:,:,1) = -0.147 * U_show(:,:,1);
U_show(:,:,2) = -0.289 * U_show(:,:,2);
U_show(:,:,3) = +0.437 * U_show(:,:,3);
U_show = U_show + 0.5;

V_show = RGB;
V_show(:,:,1) = +0.615 * V_show(:,:,1);
V_show(:,:,2) = -0.515 * V_show(:,:,2);
V_show(:,:,3) = +0.100 * V_show(:,:,3);
V_show = V_show + 0.5;

subplot(2,3,1)
imshow(Y);
title('Y image');
subplot(2,3,2)
imshow(U_show);
title('U image');
subplot(2,3,3)
imshow(V_show);
title('V image');

% YUV2RGB
RGB = zeros(size(RGB));
RGB(:,:,1) = Y + 1.140 * V;
RGB(:,:,2) = Y - 0.395 * U - 0.581 * V;
RGB(:,:,3) = Y + 2.032 * U;

R_show=RGB;R_show(:,:,[2 3])=0;
G_show=RGB;G_show(:,:,[1 3])=0;
B_show=RGB;B_show(:,:,[1 2])=0;

subplot(2,3,4)
imshow(R_show);
title('R image');
subplot(2,3,5)
imshow(G_show);
title('G image');
subplot(2,3,6)
imshow(B_show);
title('B image');

figure; 
imshow(RGB)
title('Reconstructed image');
% After YUV to RGB, The Image should same with original image.


 